export declare enum UserErrorT {
    BadIncomingRpcCallId = 0,
    BadRemoteComponentPropType = 1,
    RequiredPropMissing = 2,
    LocalPropMissing = 3
}
export declare class UserError extends Error {
    type: UserErrorT;
    humanReadable: string;
    constructor(type: UserErrorT, humanReadable: string);
}
export declare const badIncomingRpcCallId: (id: number) => UserError;
export declare const requiredPropMissing: (propKey: string, component: any) => UserError;
export declare const badPropType: (propKey: string, prop: unknown, component: any) => UserError;
export declare const localPropMissing: (propKey: string, component: any) => UserError;
//# sourceMappingURL=Error.d.ts.map